﻿  //////////////////////////////////////////////////////////////
// Classe TexteMath pour écrire des expressions Mathématiques  //
// Développée pour TracenPoche (c) Sésamath E.OSTENNE          //
// contact@sesamath.net emmanuel.ostenne@sesamath.net          //  
// sous licence CeCILL 2 - 18/04/08                            //
////////////////////////////////////////////////////////////////
dynamic class TexteMath {
	//
	//  var textemath = new TexteMath(un_mc,"£f(1,)");
	//  textemath.ecriture();
	//             1
	//    donnera ---
	//             3
	//  textemath.detruitEcriture();
	//     pour détuire les objets internes avant un
	//  delete textemath;
	//
	// angle, crochets, exposant, fraction, indice,paraenthèses,système,racine, vecteur :
	// £a,£c,£e,£f,£i,£p,£r,£s,£v (si le marqueur est £)
	//
	private var le_mc:MovieClip;
	//clip parent d'accueil du rendu
	private var la_formule:String;
	//formule de l'écriture
	private var le_tableau:Array;
	//décomposition de la formule
	private var le_marqueur:String;
	//caractère marqueur: £ par défaut
	private var la_taille_police:Number;
	//12 par défaut
	private var le_carMath:CarMath;
	//affectations pour conversions
	public var texteToHTMLFonc:Function;
	//texteToHTMLFonc(chaine, taille, couleur, effet)->string
	private var la_couleur:Number;
	//pour texteToHTMLTexte
	private var le_style:Number;
	//pour texteToHTMLTexte : 50+-:taille+- +100:italic +200:gras +300:italique_gras
	private var les_textes_input:Array;
	//
	function TexteMath(mc:MovieClip, formule:String, marqueur:String, taille:Number, couleur:Number, style:Number, dessine:Boolean, texteToHTML:Function, carMath:CarMath) {
		// style, dessine, texteToHTML, traiteSymboles sont optionnels
		this.le_mc = mc;
		this.le_mc.textemathid = this;
		if (formule != undefined) {
			this.la_formule = formule;
			this.adapteFormule();
		} else {
			this.la_formule = "";
		}
		this.le_tableau = new Array();
		if (marqueur != undefined) {
			this.le_marqueur = marqueur;
		} else {
			this.le_marqueur = "£";
		}
		if (taille != undefined) {
			this.la_taille_police = taille;
		} else {
			this.la_taille_police = 12;
		}
		if (couleur != undefined) {
			this.la_couleur = couleur;
		} else {
			this.la_couleur = 0;
		}
		if (style != undefined) {
			this.le_style = style;
		} else {
			this.le_style = 0;
		}
		if (texteToHTML != undefined) {
			this.texteToHTMLFonc = texteToHTML;
		} else {
			this.texteToHTMLFonc = texteToHTMLTexte;
		}
		if (carMath != undefined) {
			this.le_carMath = carMath;
		} else {
			this.le_carMath = new CarMath("", this.le_marqueur);
		}
		les_textes_input = new Array();
		if (dessine == true) {
			if (this.formule != "") {
				this.prepareEcriture();
				if (this.le_mc != undefined) {
					this.dessineEcriture();
				}
			}
		}
	}
	//
	public function set formule(chaine:String) {
		this.la_formule = chaine;
		this.adapteFormule();
	}
	//
	public function get formule():String {
		return this.la_formule;
	}
	//
	public function set marqueur(chaine:String) {
		this.le_marqueur = chaine;
	}
	//
	public function get marqueur():String {
		return this.le_marqueur;
	}
	//
	public function get tableau():Array {
		return this.le_tableau;
	}
	//
	public function set taille_police(valeur:Number) {
		this.la_taille_police = valeur;
	}
	//
	public function get taille_police():Number {
		return this.la_taille_police;
	}
	//
	public function set couleur(valeur:Number) {
		this.la_couleur = valeur;
	}
	//
	public function get couleur():Number {
		return this.la_couleur;
	}
	//
	public function set style(valeur:Number) {
		this.le_style = valeur;
	}
	//
	public function get style():Number {
		return this.le_style;
	}
	//
	public function setChamp(num:Number, valeur:String) {
		this.les_textes_input[num].text = valeur;
	}
	//
	public function getChamp(num:Number):String {
		return this.les_textes_input[num].text;
	}
	//
	public function prepareEcriture() {
		// on purge l'existant éventuel
		this.detruitEcriture();
		//magique : puissant !
		this.le_carMath.chaine = this.la_formule;
		//
		this.le_tableau = this.texteToTableauMef(this.le_carMath.chaine);
		this.prepareNiveaux(this.le_tableau, this.le_mc);
	}
	//
	public function dessineEcriture() {
		if (this.le_mc.hauteur != undefined) {
			this.dessineNiveaux(this.le_tableau, this.le_mc);
		}
	}
	//
	public function detruitEcriture() {
		if (this.le_tableau.length>0) {
			this.detruitTableau(this.le_tableau);
		}
		if (this.le_mc.hauteur != undefined) {
			this.detruitNiveaux(this.le_tableau, this.le_mc);
			while (this.les_textes_input.length>0) {
				this.les_textes_input.pop();
			}
		}
	}
	//
	public function ecriture() {
		this.prepareEcriture();
		this.dessineEcriture();
	}
	//
	/////////////////////////////////////////////////////////////////////////
	// Utilitaires
	/////////////////////////////////////////////////////////////////////////
	//
	function texteToHTMLTexte(chaine:String, taille:Number, couleur:Number, effet:Number):String {
		//effet:50+-:taille  +100:italic +200:gras +300:italic_gras
		var chainetexte:String;
		chainetexte = "<font color='#"+couleur.toString(16)+"' size='"+(taille+((effet%100)-50)*2)+"'>";
		if (effet%1000>300) {
			chainetexte = chainetexte+"<b><i>"+chaine+"</i></b>";
		} else {
			if (effet%1000>200) {
				chainetexte = chainetexte+"<b>"+chaine+"</b>";
			} else {
				if (effet%1000>100) {
					chainetexte = chainetexte+"<i>"+chaine+"</i>";
				} else {
					chainetexte = chainetexte+chaine;
				}
			}
		}
		chainetexte = chainetexte+"</font>";
		return chainetexte;
	}
	//
	//
	private function estdansliste(c:String, liste:Array):Boolean {
		for (var i:Number = 0; i<=liste.length; i++) {
			if (c == liste[i]) {
				return true;
			}
		}
		return false;
	}
	//
	//
	private function adapteFormule() {
		if (this.la_formule !== "") {
			//on remplace << par < codé html : &lt;
			this.la_formule = this.la_formule.split("<<").join("&lt;");
			//on remplace * par le symbole fois, sauf si * est doublé : **
			this.la_formule = this.la_formule.split("**").join("@¨fois¨@").split("*").join("£fois£").split("@¨fois¨@").join("*");
			//on remplace + par le symbole +
			this.la_formule = this.la_formule.split("+").join("£plus£");
			//on remplace - par le symbole -
			this.la_formule = this.la_formule.split("-").join("£moins£");
		}
	}
	//
	/////////////////////////////////////////////////////////////////////////
	// Gestion Tableau
	/////////////////////////////////////////////////////////////////////////
	//
	private function traceTableau(tab:Object, prof:Number) {
		//pour le debogage : trace
		var profondeur:Number = prof;
		var espace:String = "";
		var t:String = "";
		for (var i:Number = 0; i<profondeur; i++) {
			espace += " ";
		}
		for (var i:Number = 0; i<tab.length; i++) {
			t = ""+tab[i];
			if (t.length != tab[i].length) {
				this.traceTableau(tab[i], profondeur+2);
			} else {
				if (t == "") {
					t = "...";
				}
				trace(">"+espace+t);
			}
		}
	}
	//
	public function detruitTableau(tab:Object) {
		var t:String = "";
		for (var i:Number = 0; i<tab.length; i++) {
			t = ""+tab[i];
			if (t.length != tab[i].length) {
				this.detruitTableau(tab[i]);
				delete tab[i];
			}
		}
	}
	//
	private function compteNiveaux(tab:Object):Number {
		//non utilisée
		var n:Number = 0;
		var t:String = "";
		for (var i:Number = 0; i<tab.length; i++) {
			t = ""+le_tableau[i];
			if (t.length != tab[i].length) {
				//trace(">>>"+tab[i]);
				if (tab[i][0].indexOf(this.le_marqueur) == 0) {
					if (estdansliste(tab[i][0].substr(1), ["e", "f", "i", "g", "l", "s"])) {
						n = n+2;
						// sauf pour s -> simulation
					}
				}
				n = n+this.compteNiveaux(tab[i]);
			}
		}
		return n;
	}
	//
	private function trouveNextPFerme(chaine:String, posdeb:Number):Number {
		var cpo:Number = 1;
		var ppos:Number = posdeb+1;
		var c:String = "";
		for (; (ppos<chaine.length) and (cpo != 0); ppos++) {
			c = chaine.charAt(ppos);
			switch (c) {
			case "(" :
				cpo++;
				break;
			case ")" :
				cpo--;
				break;
			}
		}
		if (cpo == 0) {
			return ppos;
		} else {
			return -1;
		}
	}
	//
	private function trouveVirgSep(chaine:String, posdeb:Number):Number {
		var cpo:Number = 0;
		var ppos:Number = posdeb+1;
		var found:Boolean = false;
		var c:String = "";
		for (; (ppos<chaine.length) and !(found); ppos++) {
			c = chaine.charAt(ppos);
			switch (c) {
			case "(" :
				cpo++;
				break;
			case ")" :
				cpo--;
				break;
			case "," :
				found = (cpo == 0);
				break;
			}
		}
		if (cpo == 0) {
			return ppos;
		} else {
			return -1;
		}
	}
	//
	private function texteToTableauMef(chaine:String):Array {
		var res:Array = new Array();
		var tab0:String = "";
		var tab1:String = chaine;
		var cpos:Number = tab1.indexOf(this.le_marqueur);
		var res1:Array;
		var p2:Number = 0;
		//trace("cpos init:"+cpos);
		while (cpos>=0) {
			tab0 = tab1.substr(0, cpos);
			//trace(">>"+tab0);
			res.push(tab0);
			tab1 = tab1.substr(cpos+1);
			//trace("??"+tab1);
			var op:Number = tab1.indexOf("(");
			var ope:String = tab1.substr(0, op);
			if (this.estdansliste(ope, ["?", "a", "c", "d", "e", "f", "g", "i", "l", "n", "p", "r", "s", "u", "v"])) {
				//trace("ope="+ope);
				if ((ope == "s") || (ope == "l")) {
					res1 = new Array();
					res1.push(this.le_marqueur+ope);
					var p1:Number = 0;
					var op1:String = "";
					op++;
					p2 = this.trouveNextPFerme(tab1, op);
					p1 = this.trouveVirgSep(tab1, op);
					while (p1 != -1) {
						op1 = tab1.substring(op, p1-1);
						//trace("op1="+op1);
						res1.push(this.texteToTableauMef(op1));
						op = p1;
						p1 = trouveVirgSep(tab1, op);
					}
					var op2:String = tab1.substring(op, p2-1);
					//trace("op2="+op2);
					res1.push(this.texteToTableauMef(op2));
					//trace("res s:"+res1);
				} else if (ope == "g") {
					res1 = new Array();
					res1.push(this.le_marqueur+ope);
					var p1:Number = 0;
					var op1:String = "";
					var pasop:Number = 0;
					var tempop:String = "";
					op++;
					p2 = this.trouveNextPFerme(tab1, op);
					p1 = this.trouveVirgSep(tab1, op);
					while (p1 != -1) {
						op1 = tab1.substring(op, p1-1);
						trace("op1="+op1);
						if (pasop == 0) {
							tempop = op1;
						} else {
							if (pasop == 1) {
								trace("op1 1 = "+op1);
								if (op1.substr(0, 1) == ",") {
									res1.push(this.texteToTableauMef(tempop));
									pasop++;
									op1 = op1.substr(1, op1.length-1);
									tempop = "";
									trace("op1 modifié="+op1);
								} else {
									if (op1 !== " ") {
										tempop += " d";
									} else {
										op1 = "";
									}
								}
							}
							res1.push(this.texteToTableauMef(tempop+op1));
							tempop = "";
						}
						op = p1;
						p1 = trouveVirgSep(tab1, op);
						pasop++;
					}
					var op2:String = tab1.substring(op, p2-1);
					trace("op2="+op2);
					if (pasop == 1) {
						if (op2.substr(0, 1) == ",") {
							res1.push(this.texteToTableauMef(tempop));
							op2 = op2.substr(1, op2.length-1);
							tempop = "";
							trace("op2 modifié="+op2);
						} else {
							if (op2 !== " ") {
								tempop += " d";
							} else {
								op2 = "";
							}
						}
						res1.push(this.texteToTableauMef(tempop+op2));
					} else {
						if (op2.substr(0, 1) == ",") {
							res1.push(this.texteToTableauMef(tempop));
							op2 = op2.substr(1, op2.length-1);
							tempop = "";
							trace("op2 modifié="+op2);
						}
						res1.push(this.texteToTableauMef(op2));
					}
					trace("res s brut:"+res1);
					//** en cas d'absence de paramètres **
					if (res1.length == 1) {
						res1.push([""]);
					}
					if (res1.length == 2) {
						res1.push([""]);
					}
					if (res1.length == 3) {
						res1.push([""]);
					}
					trace("res s corr:"+res1);
				} else if (estdansliste(ope, ["e", "f", "i"])) {
					var p1:Number = this.trouveVirgSep(tab1, op);
					p2 = this.trouveNextPFerme(tab1, op);
					var op1:String = tab1.substring(op+1, p1-1);
					var op2:String = tab1.substring(p1, p2-1);
					//trace("op1="+op1);
					//trace("op2="+op2);
					res1 = new Array();
					res1.push(this.le_marqueur+ope);
					res1.push(this.texteToTableauMef(op1));
					res1.push(this.texteToTableauMef(op2));
				} else {
					p2 = this.trouveNextPFerme(tab1, op);
					var op1:String = tab1.substring(op+1, p2-1);
					//trace("op1="+op1);
					res1 = new Array();
					res1.push(this.le_marqueur+ope);
					res1.push(this.texteToTableauMef(op1));
				}
				//trace("res1="+res1);
				tab1 = tab1.substr(p2);
				res.push(res1);
			}
			cpos = tab1.indexOf(this.le_marqueur);
		}
		if (cpos<0) {
			//trace("0>"+tab1);
			res.push(tab1);
		}
		//trace("fin texteToMef");
		return res;
	}
	//
	/////////////////////////////////////////////////////////////////////////
	// Rendu graphique
	/////////////////////////////////////////////////////////////////////////
	//
	private function prepareNiveaux(tab:Array, parent:MovieClip) {
		if (this.le_mc == undefined) {
			trace("TexteMath : Erreur MovieClip parent non affecté !");
			trace("   new TexteMath(mc_parent,formule,...)");
			trace("...traitement interrompu.");
			return;
		}
		// hauteur globale du niveau
		parent.hauteur = 0;
		parent.posbas = 0;
		// taille de la police "réduite" pour exposant et indice
		parent.taille = this.la_taille_police;
		//
		var ok:Boolean = true;
		var t:String = "";
		for (var i:Number = 0; i<tab.length; i++) {
			// parent contient tout les clips modules : "enfant"+i
			// dans ce clip, on trouve un clip "enfant" qui contient
			// le clip (ou les clips pour fraction) où sont représentés
			// les sous modules
			// on pourra embellir dans le clip "enfant" :
			// dessin de la racine, trait de fraction, position des sous-modules ...
			//
			// détecte si on a un texte ou un tableau !
			t = ""+le_tableau[i];
			ok = (t.length != tab[i].length);
			if (ok) {
				//c'est un tableau,
				//détecte le marqueur en position 0
				ok = (tab[i][0].indexOf(this.le_marqueur) == 0);
				if (ok) {
					//marquer connu
					var c:String = tab[i][0].substr(1);
					switch (c) {
					case "f" :
					case "e" :
					case "i" :
						parent.createEmptyMovieClip("enfant"+i, i);
						parent["enfant"+i].createEmptyMovieClip("enfant", 0);
						parent["enfant"+i]["enfant"].createEmptyMovieClip("enfant0", 0);
						prepareNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						parent["enfant"+i]["enfant"].createEmptyMovieClip("enfant1", 1);
						prepareNiveaux(tab[i][2], parent["enfant"+i]["enfant"]["enfant1"]);
						break;
					case "?" :
						parent.createEmptyMovieClip("enfant"+i, i);
						parent["enfant"+i].createEmptyMovieClip("enfant", 0);
						parent["enfant"+i]["enfant"].createTextField("texte", 0, 0, 0, 0, 5);
						var tf:TextFormat = new TextFormat();
						tf.size = this.la_taille_police;
						parent["enfant"+i]["enfant"]["texte"].setNewTextFormat(tf);
						parent["enfant"+i]["enfant"]["texte"].html = false;
						parent["enfant"+i]["enfant"]["texte"].autoSize = true;
						parent["enfant"+i]["enfant"]["texte"].selectable = true;
						parent["enfant"+i]["enfant"]["texte"].border = true;
						parent["enfant"+i]["enfant"]["texte"].hscroll = 0;
						parent["enfant"+i]["enfant"]["texte"].type = "input";
						var ts:String = "";
						var ls:Number = (""+tab[i][1])-0;
						//trace(ls);
						if (""+ls == "NaN") {
							ts = tab[i][1];
							parent["enfant"+i]["enfant"]["texte"].maxChars = ts.length;
						} else {
							parent["enfant"+i]["enfant"]["texte"].maxChars = ls;
							for (var ki:Number = 0; ki<ls; ki++) {
								ts += "?";
							}
						}
						parent["enfant"+i]["enfant"]["texte"].text = ts;
						//tab[i][1] fois
						this.les_textes_input.push(parent["enfant"+i]["enfant"]["texte"]);
						break;
					case "a" :
					case "c" :
					case "d" :
					case "n" :
					case "p" :
					case "r" :
					case "u" :
					case "v" :
						parent.createEmptyMovieClip("enfant"+i, i);
						parent["enfant"+i].createEmptyMovieClip("enfant", 0);
						parent["enfant"+i]["enfant"].createEmptyMovieClip("enfant0", 0);
						prepareNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						break;
					case "s" :
						parent.createEmptyMovieClip("enfant"+i, i);
						parent["enfant"+i].createEmptyMovieClip("enfant", 0);
						//trace("tab :"+tab[i].length);
						for (var j:Number = 0; j<tab[i].length-1; j++) {
							parent["enfant"+i]["enfant"].createEmptyMovieClip("enfant"+j, j);
							//trace("tab "+j+" :"+tab[i][j]);
							prepareNiveaux(tab[i][j+1], parent["enfant"+i]["enfant"]["enfant"+j]);
						}
						break;
					case "g" :
						parent.createEmptyMovieClip("enfant"+i, i);
						parent["enfant"+i].createEmptyMovieClip("enfant", 0);
						parent["enfant"+i]["enfant"].createEmptyMovieClip("enfant0", 0);
						prepareNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						parent["enfant"+i]["enfant"].createEmptyMovieClip("enfant1", 1);
						prepareNiveaux(tab[i][2], parent["enfant"+i]["enfant"]["enfant1"]);
						parent["enfant"+i]["enfant"].createEmptyMovieClip("enfant2", 2);
						prepareNiveaux(tab[i][3], parent["enfant"+i]["enfant"]["enfant2"]);
						break;
					default :
						//sera considéré comme texte
						ok = false;
					}
				} else {
					ok = false;
				}
			} else {
				ok = false;
			}
			if (!ok) {
				//c'est un texte ou considéré comme tel !
				parent.createEmptyMovieClip("enfant"+i, i);
				parent["enfant"+i].createEmptyMovieClip("enfant", 0);
				parent["enfant"+i]["enfant"].createTextField("texte", 0, 0, 0, 0, 5);
				parent["enfant"+i]["enfant"]["texte"].html = true;
				parent["enfant"+i]["enfant"]["texte"].autoSize = true;
				parent["enfant"+i]["enfant"]["texte"].selectable = false;
				parent["enfant"+i]["enfant"].ypos = 0;
			}
			parent["enfant"+i]["enfant"].ypos = 0;
			parent["enfant"+i]["enfant"].posbas = 0;
		}
	}
	//
	private function detruitNiveaux(tab:Array, parent:MovieClip) {
		//
		var ok:Boolean = true;
		var t:String = "";
		for (var i:Number = 0; i<tab.length; i++) {
			t = ""+tab[i];
			ok = (t.length != le_tableau[i].length);
			if (ok) {
				ok = (tab[i][0].indexOf(this.le_marqueur) == 0);
				if (ok) {
					var c:String = tab[i][0].substr(1);
					switch (c) {
					case "f" :
					case "e" :
					case "i" :
						detruitNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						detruitNiveaux(tab[i][2], parent["enfant"+i]["enfant"]["enfant1"]);
						parent["enfant"+i]["enfant"]["enfant1"].removeMovieClip();
						parent["enfant"+i]["enfant"]["enfant0"].removeMovieClip();
						parent["enfant"+i]["enfant"].removeMovieClip();
						parent["enfant"+i].removeMovieClip();
						break;
					case "?" :
						parent["enfant"+i]["enfant"]["texte"].removeTextField();
						parent["enfant"+i]["enfant"].removeMovieClip();
						parent["enfant"+i].removeMovieClip();
						break;
					case "a" :
					case "c" :
					case "d" :
					case "n" :
					case "p" :
					case "r" :
					case "u" :
					case "v" :
						detruitNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						parent["enfant"+i]["enfant"]["enfant0"].removeMovieClip();
						parent["enfant"+i]["enfant"].removeMovieClip();
						parent["enfant"+i].removeMovieClip();
						break;
					case "s" :
						for (var j:Number = 0; j<tab[i].length-1; j++) {
							detruitNiveaux(tab[i][j+1], parent["enfant"+i]["enfant"]["enfant"+j]);
							parent["enfant"+i]["enfant"]["enfant"+j].removeMovieClip();
						}
						parent["enfant"+i]["enfant"].removeMovieClip();
						parent["enfant"+i].removeMovieClip();
						break;
					case "g" :
						detruitNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						detruitNiveaux(tab[i][2], parent["enfant"+i]["enfant"]["enfant1"]);
						detruitNiveaux(tab[i][3], parent["enfant"+i]["enfant"]["enfant2"]);
						parent["enfant"+i]["enfant"]["enfant2"].removeMovieClip();
						parent["enfant"+i]["enfant"]["enfant1"].removeMovieClip();
						parent["enfant"+i]["enfant"]["enfant0"].removeMovieClip();
						parent["enfant"+i]["enfant"].removeMovieClip();
						parent["enfant"+i].removeMovieClip();
						break;
					default :
						//sera considéré comme texte
						ok = false;
					}
				} else {
					ok = false;
				}
			} else {
				ok = false;
			}
			if (!ok) {
				//c'est un texte ou considéré comme tel !
				parent["enfant"+i]["enfant"]["texte"].removeTextField();
				parent["enfant"+i]["enfant"].removeMovieClip();
				parent["enfant"+i].removeMovieClip();
			}
		}
	}
	private function accolade(mc:MovieClip, x:Number, y:Number, l:Number, h:Number) {
		//trace("accolade :"+x+"-"+y+"-"+l+"-"+h);
		var lx:Number = x+l;
		var epais:Number = (this.le_style%1000>200) ? 2 : 1;
		mc.lineStyle(epais, this.la_couleur, 100);
		mc.moveTo(0, 0);
		mc.moveTo(lx, y);
		mc.curveTo(lx-l/2, y, lx-l/2, y+h/10);
		mc.curveTo(lx-l/2, lx+9*h/20);
		mc.curveTo(lx-l/2, y+h/2, lx-l, y+h/2);
		mc.moveTo(lx, y+h);
		mc.curveTo(lx-l/2, y+h, lx-l/2, y+9*h/10);
		mc.curveTo(lx-l/2, y+11*h/20);
		mc.curveTo(lx-l/2, y+h/2, lx-l, y+h/2);
		/*mc.lineStyle(1, this.la_couleur, 100);
		mc.moveTo(0,0);
		mc.moveTo(lx,y);
		mc.curveTo(lx-l/2 ,y, lx-l/2, y+h/10);
		mc.curveTo(lx-l/2 , lx+9*h/20);
		mc.curveTo(lx-l/2, y+h/2, lx-l, y+h/2);
		mc.moveTo(lx,y+h);
		mc.curveTo(lx-l/2, y+h, lx-l/2, y+9*h/10);
		mc.lineTo(lx-l/2, y+11*h/20);
		mc.curveTo(lx-l/2, y+h/2, lx-l, y+h/2);*/
	}
	private function dessineNiveaux(tab:Array, parent:MovieClip) {
		//position horizontale des différents modules
		var xpos:Number = 0;
		//largeur max du numérateur ou dénominateur (fractions)
		var lmax:Number = 0;
		//pour la hauteur des systèmes
		var hpos:Number = 0;
		//position relative de la partie basse d'un module : bas d'un texte, trait de fraction ...
		//pour régler l'alignement vertical
		var posbas:Number = 0;
		//
		var ok:Boolean = true;
		var t:String = "";
		//
		for (var i:Number = 0; i<tab.length; i++) {
			//position horizontale des différents modules
			parent["enfant"+i]._x = xpos;
			// détecte si on a un texte ou un tableau !
			t = ""+tab[i];
			ok = (t.length != tab[i].length);
			if (ok) {
				//c'est un tableau,
				//détecte le marqueur en position 0
				ok = (tab[i][0].indexOf(this.le_marqueur) == 0);
				if (ok) {
					//marquer connu
					var c:String = tab[i][0].substr(1);
					switch (c) {
					case "?" :
						// *** SAISIE ***
						var lwi:Number = parent["enfant"+i]["enfant"]["texte"]._width+3;
						parent["enfant"+i]["enfant"]["texte"].autoSize = false;
						parent["enfant"+i]["enfant"]["texte"]._width = lwi;
						Selection.setFocus(parent["enfant"+i]["enfant"]["texte"]);
						Selection.setSelection(0, 0);
						//trace(parent["enfant"+i]["enfant"]["texte"]._width);
						//parent["enfant"+i]["enfant"]["texte"].autoSize=false;
						//parent["enfant"+i]["enfant"]["texte"].Text = tab[i];
						parent["enfant"+i]["enfant"].ypos = parent["enfant"+i]["enfant"]["texte"]._height;
						posbas = Math.max(posbas, parent["enfant"+i]["enfant"].ypos);
						//
						xpos += parent["enfant"+i]._width;
						//parent["enfant"+i]["enfant"].focusRect();
						parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["texte"]._height);
						//
						break;
					case "a" :
						// *** ANGLE ***
						this.dessineNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						//
						parent["enfant"+i]["enfant"]["enfant0"]._y += 5;
						//parent["enfant"+i]["enfant"]["enfant0"].focusRect();
						//
						var epais:Number = (this.le_style%1000>200) ? 2 : 1;
						parent["enfant"+i]["enfant"].lineStyle(epais, this.la_couleur, 100);
						parent["enfant"+i]["enfant"].moveTo(0, 0);
						parent["enfant"+i]["enfant"].moveTo(0, 5);
						parent["enfant"+i]["enfant"].lineTo(parent["enfant"+i]["enfant"]["enfant0"]._width/2, 1);
						parent["enfant"+i]["enfant"].lineTo(parent["enfant"+i]["enfant"]["enfant0"]._width, 5);
						//
						parent["enfant"+i]["enfant"].ypos = parent["enfant"+i]["enfant"]["enfant0"].hauteur+5;
						posbas = Math.max(posbas, parent["enfant"+i]["enfant"].ypos);
						//
						parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["enfant0"].hauteur+5);
						//
						xpos += parent["enfant"+i]["enfant"]._width;
						break;
					case "c" :
						// *** CROCHETS ***
						this.dessineNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						//
						parent["enfant"+i]["enfant"]["enfant0"]._x += 2;
						parent["enfant"+i]["enfant"]["enfant0"]._y += 2;
						//
						var epais:Number = (this.le_style%1000>200) ? 2 : 1;
						parent["enfant"+i]["enfant"].lineStyle(epais, this.la_couleur, 100);
						parent["enfant"+i]["enfant"].moveTo(0, 0);
						parent["enfant"+i]["enfant"].moveTo(5, 1);
						parent["enfant"+i]["enfant"].lineTo(0, 1);
						parent["enfant"+i]["enfant"].lineTo(0, parent["enfant"+i]["enfant"]["enfant0"].hauteur+4);
						parent["enfant"+i]["enfant"].lineTo(5, parent["enfant"+i]["enfant"]["enfant0"].hauteur+4);
						parent["enfant"+i]["enfant"].moveTo(parent["enfant"+i]["enfant"]["enfant0"]._width, 1);
						parent["enfant"+i]["enfant"].lineTo(parent["enfant"+i]["enfant"]["enfant0"]._width+5, 1);
						parent["enfant"+i]["enfant"].lineTo(parent["enfant"+i]["enfant"]["enfant0"]._width+5, parent["enfant"+i]["enfant"]["enfant0"].hauteur+4);
						parent["enfant"+i]["enfant"].lineTo(parent["enfant"+i]["enfant"]["enfant0"]._width, parent["enfant"+i]["enfant"]["enfant0"].hauteur+4);
						//
						parent["enfant"+i]["enfant"].ypos = parent["enfant"+i]["enfant"]["enfant0"].hauteur+2;
						//["enfant0"].hauteur-6;
						posbas = Math.max(posbas, parent["enfant"+i]["enfant"].ypos);
						//+6);
						parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["enfant0"].hauteur+4);
						/*parent["enfant"+i]["enfant"].ypos = (parent["enfant"+i]["enfant"]["enfant0"].hauteur+12)/2; //["enfant0"].hauteur-6;
						posbas = Math.max(posbas, parent["enfant"+i]["enfant"]["enfant0"].hauteur); //+6);
						parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["enfant0"].hauteur+12);
						*/
						//
						//
						xpos += parent["enfant"+i]["enfant"]._width;
						break;
					case "d" :
						// *** DISTANCE A ZERO / VALEUR ABSOLUE ***
						this.dessineNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						//
						parent["enfant"+i]["enfant"]["enfant0"]._x += 2;
						parent["enfant"+i]["enfant"]["enfant0"]._y += 2;
						//
						var epais:Number = (this.le_style%1000>200) ? 2 : 1;
						parent["enfant"+i]["enfant"].lineStyle(epais, this.la_couleur, 100);
						parent["enfant"+i]["enfant"].moveTo(0, 1);
						parent["enfant"+i]["enfant"].lineTo(0, parent["enfant"+i]["enfant"]["enfant0"].hauteur+4);
						parent["enfant"+i]["enfant"].moveTo(parent["enfant"+i]["enfant"]["enfant0"]._width+5, 1);
						parent["enfant"+i]["enfant"].lineTo(parent["enfant"+i]["enfant"]["enfant0"]._width+5, parent["enfant"+i]["enfant"]["enfant0"].hauteur+4);
						//
						parent["enfant"+i]["enfant"].ypos = parent["enfant"+i]["enfant"]["enfant0"].hauteur+2;
						//["enfant0"].hauteur-6;
						posbas = Math.max(posbas, parent["enfant"+i]["enfant"].ypos);
						//+6);
						parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["enfant0"].hauteur+4);
						/*parent["enfant"+i]["enfant"].ypos = (parent["enfant"+i]["enfant"]["enfant0"].hauteur+12)/2; //["enfant0"].hauteur-6;
						posbas = Math.max(posbas, parent["enfant"+i]["enfant"]["enfant0"].hauteur); //+6);
						parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["enfant0"].hauteur+12);
						*/
						//
						//
						xpos += parent["enfant"+i]["enfant"]._width;
						break;
					case "e" :
						// *** EXPOSANT ***
						this.dessineNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						this.dessineNiveaux(tab[i][2], parent["enfant"+i]["enfant"]["enfant1"]);
						//
						parent["enfant"+i]["enfant"]["enfant1"]._xscale = 75;
						parent["enfant"+i]["enfant"]["enfant1"]._yscale = 75;
						parent["enfant"+i]["enfant"]["enfant1"].hauteur *= 0.75;
						parent["enfant"+i]["enfant"]["enfant1"]._x = parent["enfant"+i]["enfant"]["enfant0"]._x+parent["enfant"+i]["enfant"]["enfant0"]._width-3;
						parent["enfant"+i]["enfant"]["enfant1"]._y = 0;
						parent["enfant"+i]["enfant"]["enfant0"]._y = parent["enfant"+i]["enfant"]["enfant1"].hauteur-this.la_taille_police/3;
						//
						//
						parent["enfant"+i]["enfant"].ypos = parent["enfant"+i]["enfant"]["enfant0"]._y+parent["enfant"+i]["enfant"]["enfant0"].hauteur;
						//
						posbas = Math.max(posbas, parent["enfant"+i]["enfant"].ypos);
						parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["enfant0"].hauteur+parent["enfant"+i]["enfant"]["enfant1"].hauteur-this.la_taille_police/3);
						//
						xpos += parent["enfant"+i]["enfant"]["enfant1"]._x+parent["enfant"+i]["enfant"]["enfant1"]._width;
						break;
					case "f" :
						// *** FRACTION ***
						this.dessineNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						this.dessineNiveaux(tab[i][2], parent["enfant"+i]["enfant"]["enfant1"]);
						//
						lmax = Math.max(parent["enfant"+i]["enfant"]["enfant0"]._width, parent["enfant"+i]["enfant"]["enfant1"]._width);
						parent["enfant"+i]["enfant"]["enfant0"]._x = (lmax-parent["enfant"+i]["enfant"]["enfant0"]._width)/2;
						parent["enfant"+i]["enfant"]["enfant1"]._x = (lmax-parent["enfant"+i]["enfant"]["enfant1"]._width)/2;
						parent["enfant"+i]["enfant"]["enfant0"]._y = 0;
						parent["enfant"+i]["enfant"]["enfant1"]._y = parent["enfant"+i]["enfant"]["enfant0"].hauteur+4;
						//
						var epais:Number = (this.le_style%1000>200) ? 2 : 1;
						parent["enfant"+i]["enfant"].lineStyle(epais, this.la_couleur, 100);
						parent["enfant"+i]["enfant"].moveTo(0, 0);
						parent["enfant"+i]["enfant"].moveTo(1, parent["enfant"+i]["enfant"]["enfant0"].hauteur+2);
						parent["enfant"+i]["enfant"].lineTo(lmax, parent["enfant"+i]["enfant"]["enfant0"].hauteur+2);
						//
						parent["enfant"+i]["enfant"].ypos = parent["enfant"+i]["enfant"]["enfant0"].hauteur+5+this.la_taille_police/2;
						//
						posbas = Math.max(posbas, parent["enfant"+i]["enfant"].ypos);
						parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["enfant0"].hauteur+parent["enfant"+i]["enfant"]["enfant1"].hauteur+5);
						//
						xpos += lmax;
						break;
					case "i" :
						// *** INDICE ***
						this.dessineNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						this.dessineNiveaux(tab[i][2], parent["enfant"+i]["enfant"]["enfant1"]);
						//
						parent["enfant"+i]["enfant"]["enfant1"]._xscale = 75;
						parent["enfant"+i]["enfant"]["enfant1"]._yscale = 75;
						parent["enfant"+i]["enfant"]["enfant1"].hauteur *= 0.75;
						parent["enfant"+i]["enfant"]["enfant0"]._y = 0;
						parent["enfant"+i]["enfant"]["enfant1"]._x = parent["enfant"+i]["enfant"]["enfant0"]._x+parent["enfant"+i]["enfant"]["enfant0"]._width-3;
						parent["enfant"+i]["enfant"]["enfant1"]._y = parent["enfant"+i]["enfant"]["enfant0"].hauteur-this.la_taille_police/3;
						//
						//
						parent["enfant"+i]["enfant"].ypos = parent["enfant"+i]["enfant"]["enfant0"].hauteur;
						//
						posbas = Math.max(posbas, parent["enfant"+i]["enfant"].ypos);
						parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["enfant0"].hauteur+parent["enfant"+i]["enfant"]["enfant1"].hauteur-this.la_taille_police/3);
						//
						xpos += parent["enfant"+i]["enfant"]["enfant1"]._x+parent["enfant"+i]["enfant"]["enfant1"]._width;
						break;
					case "n" :
						// *** norme ***
						this.dessineNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						//
						parent["enfant"+i]["enfant"]["enfant0"]._x += 2;
						parent["enfant"+i]["enfant"]["enfant0"]._y += 2;
						//
						var epais:Number = (this.le_style%1000>200) ? 2 : 1;
						parent["enfant"+i]["enfant"].lineStyle(epais, this.la_couleur, 100);
						parent["enfant"+i]["enfant"].moveTo(0, 1);
						parent["enfant"+i]["enfant"].lineTo(0, parent["enfant"+i]["enfant"]["enfant0"].hauteur+4);
						parent["enfant"+i]["enfant"].moveTo(3, 1);
						parent["enfant"+i]["enfant"].lineTo(3, parent["enfant"+i]["enfant"]["enfant0"].hauteur+4);
						parent["enfant"+i]["enfant"].moveTo(parent["enfant"+i]["enfant"]["enfant0"]._width+5, 1);
						parent["enfant"+i]["enfant"].lineTo(parent["enfant"+i]["enfant"]["enfant0"]._width+5, parent["enfant"+i]["enfant"]["enfant0"].hauteur+4);
						parent["enfant"+i]["enfant"].moveTo(parent["enfant"+i]["enfant"]["enfant0"]._width+2, 1);
						parent["enfant"+i]["enfant"].lineTo(parent["enfant"+i]["enfant"]["enfant0"]._width+2, parent["enfant"+i]["enfant"]["enfant0"].hauteur+4);
						//
						parent["enfant"+i]["enfant"].ypos = parent["enfant"+i]["enfant"]["enfant0"].hauteur+2;
						//["enfant0"].hauteur-6;
						posbas = Math.max(posbas, parent["enfant"+i]["enfant"].ypos);
						//+6);
						parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["enfant0"].hauteur+4);
						/*parent["enfant"+i]["enfant"].ypos = (parent["enfant"+i]["enfant"]["enfant0"].hauteur+12)/2; //["enfant0"].hauteur-6;
						posbas = Math.max(posbas, parent["enfant"+i]["enfant"]["enfant0"].hauteur); //+6);
						parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["enfant0"].hauteur+12);
						*/
						//
						//
						xpos += parent["enfant"+i]["enfant"]._width;
						break;
					case "p" :
						// *** PARENTHESES ***
						this.dessineNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						//
						parent["enfant"+i]["enfant"]["enfant0"]._x += 2;
						parent["enfant"+i]["enfant"]["enfant0"]._y += 2;
						//
						var epais:Number = (this.le_style%1000>200) ? 2 : 1;
						parent["enfant"+i]["enfant"].lineStyle(epais, this.la_couleur, 100);
						parent["enfant"+i]["enfant"].moveTo(0, 0);
						parent["enfant"+i]["enfant"].moveTo(5, 1);
						parent["enfant"+i]["enfant"].curveTo(0, 1, 0, (parent["enfant"+i]["enfant"]["enfant0"].hauteur+2)/2);
						parent["enfant"+i]["enfant"].curveTo(0, (parent["enfant"+i]["enfant"]["enfant0"].hauteur+4), 5, parent["enfant"+i]["enfant"]["enfant0"].hauteur+4);
						parent["enfant"+i]["enfant"].moveTo(parent["enfant"+i]["enfant"]["enfant0"]._width, 1);
						parent["enfant"+i]["enfant"].curveTo(parent["enfant"+i]["enfant"]["enfant0"]._width+5, 1, parent["enfant"+i]["enfant"]["enfant0"]._width+5, (parent["enfant"+i]["enfant"]["enfant0"].hauteur+2)/2);
						parent["enfant"+i]["enfant"].curveTo(parent["enfant"+i]["enfant"]["enfant0"]._width+5, (parent["enfant"+i]["enfant"]["enfant0"].hauteur+4), parent["enfant"+i]["enfant"]["enfant0"]._width, parent["enfant"+i]["enfant"]["enfant0"].hauteur+4);
						//parent["enfant"+i]["enfant"].curveTo(-15,5,5, parent["enfant"+i]["enfant"]["enfant0"].hauteur+4);
						//
						parent["enfant"+i]["enfant"].ypos = parent["enfant"+i]["enfant"]["enfant0"].hauteur+2;
						//["enfant0"].hauteur-6;
						posbas = Math.max(posbas, parent["enfant"+i]["enfant"].ypos);
						//+6);
						parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["enfant0"].hauteur+4);
						/*parent["enfant"+i]["enfant"].ypos = (parent["enfant"+i]["enfant"]["enfant0"].hauteur+12)/2; //["enfant0"].hauteur-6;
						posbas = Math.max(posbas, parent["enfant"+i]["enfant"]["enfant0"].hauteur); //+6 ??
						parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["enfant0"].hauteur+12);
						*/
						//
						//
						xpos += parent["enfant"+i]["enfant"]._width;
						break;
					case "r" :
						// *** RACINE ***
						this.dessineNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						//
						parent["enfant"+i]["enfant"]["enfant0"]._x += 5;
						parent["enfant"+i]["enfant"]["enfant0"]._y += 2;
						//
						var epais:Number = (this.le_style%1000>200) ? 2 : 1;
						parent["enfant"+i]["enfant"].lineStyle(epais, this.la_couleur, 100);
						var italic:Boolean = false;
						if (this.le_style%1000>300) {
							italic = true;
						} else {
							if (this.le_style%1000>200) {
								italic = false;
							} else {
								if (this.le_style%1000>100) {
									italic = true;
								} else {
									italic = false;
								}
							}
						}
						if (italic) {
							parent["enfant"+i]["enfant"].moveTo(0, 0);
							parent["enfant"+i]["enfant"].moveTo(0, parent["enfant"+i]["enfant"]["enfant0"].hauteur*2/3);
							parent["enfant"+i]["enfant"].lineTo(2, parent["enfant"+i]["enfant"]["enfant0"].hauteur);
							parent["enfant"+i]["enfant"].lineTo(7, 1);
							parent["enfant"+i]["enfant"].lineTo(5+parent["enfant"+i]["enfant"]["enfant0"]._width, 1);
						} else {
							parent["enfant"+i]["enfant"].moveTo(0, 0);
							parent["enfant"+i]["enfant"].moveTo(0, parent["enfant"+i]["enfant"]["enfant0"].hauteur*2/3);
							parent["enfant"+i]["enfant"].lineTo(2, parent["enfant"+i]["enfant"]["enfant0"].hauteur);
							parent["enfant"+i]["enfant"].lineTo(5, 1);
							parent["enfant"+i]["enfant"].lineTo(5+parent["enfant"+i]["enfant"]["enfant0"]._width, 1);
						}
						//
						//parent["enfant"+i]["enfant"].ypos = parent["enfant"+i]["enfant"]["enfant0"].hauteur-6;
						//posbas = Math.max(posbas, parent["enfant"+i]["enfant"].ypos);
						//
						//
						parent["enfant"+i]["enfant"].ypos = parent["enfant"+i]["enfant"]["enfant0"].posbas+2;
						posbas = Math.max(posbas, parent["enfant"+i]["enfant"].ypos);
						//
						parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["enfant0"].hauteur+2);
						//
						xpos += parent["enfant"+i]["enfant"]._width-2;
						break;
					case "s" :
						// *** système ***
						lmax = 0;
						hpos = 4;
						//trace("tab[i] :"+tab[i]+ "-"+tab[i].length);
						for (var kj:Number = 0; kj<tab[i].length-1; kj++) {
							//trace("->"+tab[i][kj+1]);
							this.dessineNiveaux(tab[i][kj+1], parent["enfant"+i]["enfant"]["enfant"+kj]);
							lmax = Math.max(lmax, parent["enfant"+i]["enfant"]["enfant"+kj]._width);
							parent["enfant"+i]["enfant"]["enfant"+kj]._x = 6;
							parent["enfant"+i]["enfant"]["enfant"+kj]._y = hpos;
							hpos += parent["enfant"+i]["enfant"]["enfant"+kj].hauteur;
						}
						//
						this.accolade(parent["enfant"+i]["enfant"], 0, 1, 6, hpos);
						parent["enfant"+i]["enfant"].ypos = (hpos+this.la_taille_police)/2;
						//
						posbas = Math.max(posbas, parent["enfant"+i]["enfant"].ypos);
						parent.hauteur = Math.max(parent.hauteur, hpos);
						//
						xpos += lmax+6;
						break;
					case "u" :
						// *** UNICODE ***
						var ltab:Array = [String.fromCharCode("0x"+tab[i][1])];
						this.dessineNiveaux(ltab, parent["enfant"+i]["enfant"]["enfant0"]);
						//
						parent["enfant"+i]["enfant"].ypos = parent["enfant"+i]["enfant"]["enfant0"].hauteur;
						posbas = Math.max(posbas, parent["enfant"+i]["enfant"].ypos);
						//
						parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["enfant0"].hauteur);
						//
						xpos += parent["enfant"+i]["enfant"]._width;
						break;
					case "v" :
						// *** VECTEUR ***
						this.dessineNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						//
						parent["enfant"+i]["enfant"]["enfant0"]._y += 5;
						//parent["enfant"+i]["enfant"]["enfant0"].focusRect();
						//
						var epais:Number = (this.le_style%1000>200) ? 2 : 1;
						parent["enfant"+i]["enfant"].lineStyle(epais, this.la_couleur, 100);
						parent["enfant"+i]["enfant"].moveTo(0, 0);
						parent["enfant"+i]["enfant"].moveTo(0, 3);
						parent["enfant"+i]["enfant"].lineTo(parent["enfant"+i]["enfant"]["enfant0"]._width, 3);
						parent["enfant"+i]["enfant"].lineTo(parent["enfant"+i]["enfant"]["enfant0"]._width-3, 1);
						parent["enfant"+i]["enfant"].moveTo(parent["enfant"+i]["enfant"]["enfant0"]._width, 3);
						parent["enfant"+i]["enfant"].lineTo(parent["enfant"+i]["enfant"]["enfant0"]._width-3, 5);
						//
						parent["enfant"+i]["enfant"].ypos = parent["enfant"+i]["enfant"]["enfant0"].hauteur+5;
						posbas = Math.max(posbas, parent["enfant"+i]["enfant"].ypos);
						//
						parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["enfant0"].hauteur+5);
						//
						xpos += parent["enfant"+i]["enfant"]._width;
						break;
					case "g" :
						// *** INTEGRALE ***
						this.dessineNiveaux(tab[i][3], parent["enfant"+i]["enfant"]["enfant0"]);
						this.dessineNiveaux(tab[i][2], parent["enfant"+i]["enfant"]["enfant1"]);
						this.dessineNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant2"]);
						//
						parent["enfant"+i]["enfant"]["enfant0"]._xscale = 75;
						parent["enfant"+i]["enfant"]["enfant0"]._yscale = 75;
						parent["enfant"+i]["enfant"]["enfant0"].hauteur *= 0.75;
						parent["enfant"+i]["enfant"]["enfant1"]._xscale = 75;
						parent["enfant"+i]["enfant"]["enfant1"]._yscale = 75;
						parent["enfant"+i]["enfant"]["enfant1"].hauteur *= 0.75;
						lmax = Math.max(parent["enfant"+i]["enfant"]["enfant0"]._width, parent["enfant"+i]["enfant"]["enfant1"]._width);
						parent["enfant"+i]["enfant"]["enfant2"]._y = parent["enfant"+i]["enfant"]["enfant0"].hauteur;
						parent["enfant"+i]["enfant"]["enfant1"]._y = parent["enfant"+i]["enfant"]["enfant2"]._y+parent["enfant"+i]["enfant"]["enfant2"].hauteur;
						parent["enfant"+i]["enfant"]["enfant0"]._x = 8
						parent["enfant"+i]["enfant"]["enfant1"]._x = 6;
						parent["enfant"+i]["enfant"]["enfant2"]._x = 7+lmax;
						parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["enfant0"].hauteur+parent["enfant"+i]["enfant"]["enfant1"].hauteur+parent["enfant"+i]["enfant"]["enfant2"].hauteur);
						//
						var epais:Number = (this.le_style%1000>200) ? 2 : 1;
						parent["enfant"+i]["enfant"].lineStyle(epais, this.la_couleur, 100);
						parent["enfant"+i]["enfant"].moveTo(0, 0);
						parent["enfant"+i]["enfant"].moveTo(8, 3);
						parent["enfant"+i]["enfant"].curveTo(5, 0, 5, (parent.hauteur-6)/4);
						parent["enfant"+i]["enfant"].lineTo(3, (3*parent.hauteur-6)/4);
						parent["enfant"+i]["enfant"].curveTo(3, (parent.hauteur), 0, parent.hauteur-3);
						//
						parent["enfant"+i]["enfant"].ypos = parent["enfant"+i]["enfant"]["enfant1"]._y;
						//
						posbas = Math.max(posbas, parent["enfant"+i]["enfant"].ypos);
						// voir plus haut parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["enfant0"].hauteur+parent["enfant"+i]["enfant"]["enfant1"].hauteur+parent["enfant"+i]["enfant"]["enfant2"].hauteur+3);
						//
						xpos += 8+lmax+parent["enfant"+i]["enfant"]["enfant2"]._width+2;
						break;
					default :
						ok = false;
					}
				} else {
					ok = false;
				}
			} else {
				ok = false;
			}
			if (!ok) {
				//c'est un texte ou considéré comme tel !
				if (this.texteToHTMLFonc == undefined) {
					// -> texte brut
					parent["enfant"+i]["enfant"]["texte"].htmlText = tab[i];
				} else {
					// -> texte html mis en forme (codage TeP : 50+-:taille, +100:italique +200:gras +300:gras_italique
					parent["enfant"+i]["enfant"]["texte"].htmlText = this.texteToHTMLFonc(tab[i], this.la_taille_police, this.la_couleur, this.le_style);
				}
				parent["enfant"+i]["enfant"].ypos = parent["enfant"+i]["enfant"]["texte"]._height;
				posbas = Math.max(posbas, parent["enfant"+i]["enfant"].ypos);
				//
				xpos += parent["enfant"+i]._width;
				//parent["enfant"+i]["enfant"].focusRect();
				parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["texte"]._height);
				//trace("hauteurs :"+tab[i]+" : "+parent.hauteur);
			} else {
				//trace("hauteurs :"+tab[i]+" : "+parent.hauteur+" - "+parent["enfant"+i]["enfant"]["enfant0"].hauteur);
			}
		}
		//trace("posbas ="+posbas);
		//
		//on aligne verticalement ...
		for (var i:Number = 0; i<tab.length; i++) {
			parent["enfant"+i]._y = posbas-parent["enfant"+i]["enfant"].ypos;
		}
		parent.posbas = posbas;
	}
}
